import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.FontData;
import org.eclipse.swt.widgets.Canvas;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import java.io.Serializable;


public class Add implements FunctionIdentity, Serializable{
	
	//för serializable, en flagga för att detektera om man gör
	//stora ändringar i sin klass, inte ett måste men får bort en varning
	private static final long serialVersionUID = 1234L;
	
	Box box=null;
	
	//constructor
	public Add(int x,int y, Display display_in, Shell sh, Canvas ca){
		
		box = new Box(x, y, display_in, sh, ca);
		box.set_number_inputs(2);
		box.set_number_outputs(1);
		box.create_menu();//måste vara efter set_inputs/outputs eftersom menyn behöver deras värden
		box.set_height_and_width(45,45);
		box.set_title("Add");
		box.set_function_type(3);
		box.set_FunctionIdentity(this);
		
	}
	
	//ritar detta blocks utseende i boxen
	public void draw_graphics(){
		Font font = new Font( box.display, new FontData( "Arial", 20, SWT.NORMAL ) ); //namn, storlek, tjock/normal/kursiv
		box.gc.setFont(font);
		box.gc.drawText("+", box.x_start+14, box.y_start+7, true); //true gör att ingen bakgrund ritas bakom texten
	}
	
		//ger boxen detta funktionsobjekt sitter i
	public Box get_box(){
		return box;
	}
		
	//kopierar interfacet som instansierats som Add..nåt sånt...
	//blir en kopia iaf
	public FunctionIdentity copy(int x,int y, Display display_in, Shell sh, Canvas ca){
		return new Add(x, y, display_in, sh, ca);
	}
	
	//ger strängen som ska skrivas för funktionen i skriptet
	public String get_function(){
		return"Add";
	}
	
	//ger parametrar som användaren sätter för funktionen
	public String[] get_parameters(){
		return new String[]{};
	}
	
	//sträng som skrivs före loopen, "" gör att inget skrivs
	public String get_pre_loop_string(){
		return "";
	}

	//sträng som skrivs efter loopen, "" gör att inget skrivs
	public String get_post_loop_string(){
		return "";
	}

	
	//GUI:t
	public void options(){
		
	}
	
	//sker när man dubbelklickar
	public void double_click_action(){
		
	}
	
	//körs när simulering startas
	public void sim_start(){
	
	}
	
	//körs när simulering stoppas
	public void sim_stop(){
		
	}
	
	//körs när GoSim stängs
	public void end_gosim_stop(){
		
	}
	
	//körs när nån funktion skriver sträng med prefix g_s under simulering
	public void sim_update(String str){}

}
